Index: trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/src/Parameters.cpp
===================================================================
--- trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/src/Parameters.cpp	(revision 137)
+++ trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/src/Parameters.cpp	(revision 138)
@@ -1141,18 +1236,23 @@
           {
             // sort and erase duplicate value
-            {
-              sort  (_list_load_store_unit_with_rename_unit  [i][j].begin(),
-                     _list_load_store_unit_with_rename_unit  [i][j].end());
-              std::vector<uint32_t>::iterator it=unique(_list_load_store_unit_with_rename_unit  [i][j].begin(),
-                                                        _list_load_store_unit_with_rename_unit  [i][j].end());
-              _list_load_store_unit_with_rename_unit  [i][j].erase(it,_list_load_store_unit_with_rename_unit  [i][j].end());
-            }
-            {
-              sort  (_list_functionnal_unit_with_rename_unit  [i][j].begin(),
-                     _list_functionnal_unit_with_rename_unit  [i][j].end());
-              std::vector<uint32_t>::iterator it=unique(_list_functionnal_unit_with_rename_unit  [i][j].begin(),
-                                                        _list_functionnal_unit_with_rename_unit  [i][j].end());
-              _list_functionnal_unit_with_rename_unit  [i][j].erase(it,_list_functionnal_unit_with_rename_unit  [i][j].end());
-            }
+            _list_load_store_unit_with_rename_unit  [i][j] = sort_and_unique (_list_load_store_unit_with_rename_unit  [i][j]);
+
+            // {
+            //   sort  (_list_load_store_unit_with_rename_unit  [i][j].begin(),
+            //          _list_load_store_unit_with_rename_unit  [i][j].end());
+            //   std::vector<uint32_t>::iterator it=unique(_list_load_store_unit_with_rename_unit  [i][j].begin(),
+            //                                             _list_load_store_unit_with_rename_unit  [i][j].end());
+            //   _list_load_store_unit_with_rename_unit  [i][j].erase(it,_list_load_store_unit_with_rename_unit  [i][j].end());
+            // }
+
+            _list_functionnal_unit_with_rename_unit  [i][j] = sort_and_unique (_list_functionnal_unit_with_rename_unit  [i][j]);
+            
+            // {
+            //   sort  (_list_functionnal_unit_with_rename_unit  [i][j].begin(),
+            //          _list_functionnal_unit_with_rename_unit  [i][j].end());
+            //   std::vector<uint32_t>::iterator it=unique(_list_functionnal_unit_with_rename_unit  [i][j].begin(),
+            //                                             _list_functionnal_unit_with_rename_unit  [i][j].end());
+            //   _list_functionnal_unit_with_rename_unit  [i][j].erase(it,_list_functionnal_unit_with_rename_unit  [i][j].end());
+            // }
 
 //             uint32_t num_rename_bloc = _link_rename_bloc_with_rename_unit[i][j];
@@ -1175,15 +1275,8 @@
       }
     
-    log_printf(TRACE,Core,FUNCTION,_("  * network_table_dispatch [nb_ooo_engine][nb_inst_issue_slot][nb_execute_loop][nb_read_unit]"));
-    for (uint32_t i=0; i<_nb_ooo_engine; ++i)
-      for (uint32_t j=0; j<_nb_inst_issue_slot[i]; ++j)
-        for (uint32_t k=0; k<_nb_execute_loop; ++k)
-          for (uint32_t l=0; l<_nb_read_unit[k]; ++l)
-            if (_network_table_dispatch [i][j][k][l] == true)
-              log_printf(TRACE,Core,FUNCTION,_("   Issue Slot [%d][%d] is connected with Read_unit [%d][%d]"),i,j,k,l);
-
-    ALLOC3(_network_table_issue_type,bool,_nb_execute_loop,_nb_read_unit[it1],_nb_type);
-
-    log_printf(TRACE,Core,FUNCTION,_("  * network_table_issue_type"));
+    ALLOC3(_network_table_issue_type  ,bool,_nb_execute_loop,_nb_read_unit[it1],_nb_type);
+    ALLOC3(_network_table_issue_thread,bool,_nb_execute_loop,_nb_read_unit[it1],_nb_thread);
+
+    log_printf(TRACE,Core,FUNCTION,_("  * network_table_issue_type and network_table_issue_thread"));
     for (uint32_t i=0; i<_nb_execute_loop; ++i)
       for (uint32_t j=0; j<_nb_read_unit[i]; ++j)
@@ -1191,5 +1284,7 @@
           // init
           for (uint32_t t=0; t<_nb_type; ++t)
-            _network_table_issue_type [i][j][t] = false;
+            _network_table_issue_type   [i][j][t] = false;
+          for (uint32_t t=0; t<_nb_thread; ++t)
+            _network_table_issue_thread [i][j][t] = false;
 
           // get number of read bloc
@@ -1199,26 +1294,45 @@
           for (uint32_t k=0; k<_nb_functionnal_unit; ++k)
             if (_link_read_bloc_and_functionnal_unit [num_read_bloc][k])
-              // Scan timing table, test if have an instruction
-              for (uint32_t t=0; t<_nb_type; ++t)
-                for (uint32_t o=0; o<_nb_operation; ++o)
-                  if (_timing[k][t][o]._latence > 0)
+              {
+                // Scan timing table, test if have an instruction
+                for (uint32_t t=0; t<_nb_type; ++t)
+                  for (uint32_t o=0; o<_nb_operation; ++o)
+                    if (_timing[k][t][o]._latence > 0)
+                      {
+                        log_printf(TRACE,Core,FUNCTION,_("  * network_table_issue_type   [%d][%d][%d] -> true"),i,j,t);
+                        
+                        _network_table_issue_type [i][j][t] = true;
+                        break; // operation
+                      }
+
+                for (uint32_t t=0; t<_nb_thread; ++t)
+                  if (_link_thread_and_functionnal_unit [t][k])
                     {
-                      log_printf(TRACE,Core,FUNCTION,_("   [%d][%d][%d] -> true"),i,j,t);
+                      log_printf(TRACE,Core,FUNCTION,_("  * network_table_issue_thread [%d][%d][%d] -> true"),i,j,t);
                       
-                      _network_table_issue_type [i][j][t] = true;
-                      break; // operation
+                      _network_table_issue_thread [i][j][t] = true;
                     }
+              }
           
           // Test load store unit connected with this read bloc
           for (uint32_t k=0; k<_nb_load_store_unit; ++k)
             // Test load store unit connected with this read bloc
-            if (_link_read_bloc_and_load_store_unit [num_read_bloc][k])
+            if (_link_read_bloc_with_load_store_unit [k] == num_read_bloc)
               {
-                uint32_t t = TYPE_MEMORY;
-                
-                log_printf(TRACE,Core,FUNCTION,_("   [%d][%d][%d] -> true"),i,j,t);
-                
-                _network_table_issue_type [i][j][t] = true;
-                break; // load_store_unit
+                {
+                  uint32_t t = TYPE_MEMORY;
+                  
+                  log_printf(TRACE,Core,FUNCTION,_("  * network_table_issue_type   [%d][%d][%d] -> true"),i,j,t);
+                  
+                  _network_table_issue_type [i][j][t] = true;
+                }
+
+                for (uint32_t t=0; t<_nb_thread; ++t)
+                  if (_link_load_store_unit_with_thread[t] == k)
+                    {
+                      log_printf(TRACE,Core,FUNCTION,_("  * network_table_issue_thread [%d][%d][%d] -> true"),i,j,t);
+                      
+                      _network_table_issue_thread [i][j][t] = true;
+                    }
               }
         }
@@ -1346,5 +1460,5 @@
     ALLOC1(_list_ooo_engine_with_execute_loop                      ,std::vector<uint32_t>,_nb_execute_loop);
     ALLOC1(_list_front_end_with_execute_loop                       ,std::vector<uint32_t>,_nb_execute_loop);
-    
+
     for (uint32_t i=0; i<_nb_ooo_engine; ++i)
       {
@@ -1366,18 +1480,23 @@
     for (uint32_t i=0; i<_nb_execute_loop; ++i)
       {
-        {
-          sort  (_list_ooo_engine_with_execute_loop[i].begin(),
-                 _list_ooo_engine_with_execute_loop[i].end());
-          std::vector<uint32_t>::iterator it=unique(_list_ooo_engine_with_execute_loop[i].begin(),
-                                                    _list_ooo_engine_with_execute_loop[i].end());
-          _list_ooo_engine_with_execute_loop[i].erase(it,_list_ooo_engine_with_execute_loop[i].end());
-        }
-        {
-          sort  (_list_front_end_with_execute_loop[i].begin(),
-                 _list_front_end_with_execute_loop[i].end());
-          std::vector<uint32_t>::iterator it=unique(_list_front_end_with_execute_loop[i].begin(),
-                                                    _list_front_end_with_execute_loop[i].end());
-          _list_front_end_with_execute_loop[i].erase(it,_list_front_end_with_execute_loop[i].end());
-        }
+        _list_ooo_engine_with_execute_loop[i] = sort_and_unique (_list_ooo_engine_with_execute_loop[i]);
+
+        // {
+        //   sort  (_list_ooo_engine_with_execute_loop[i].begin(),
+        //          _list_ooo_engine_with_execute_loop[i].end());
+        //   std::vector<uint32_t>::iterator it=unique(_list_ooo_engine_with_execute_loop[i].begin(),
+        //                                             _list_ooo_engine_with_execute_loop[i].end());
+        //   _list_ooo_engine_with_execute_loop[i].erase(it,_list_ooo_engine_with_execute_loop[i].end());
+        // }
+
+        _list_front_end_with_execute_loop[i] = sort_and_unique (_list_front_end_with_execute_loop[i]);
+
+        // {
+        //   sort  (_list_front_end_with_execute_loop[i].begin(),
+        //          _list_front_end_with_execute_loop[i].end());
+        //   std::vector<uint32_t>::iterator it=unique(_list_front_end_with_execute_loop[i].begin(),
+        //                                             _list_front_end_with_execute_loop[i].end());
+        //   _list_front_end_with_execute_loop[i].erase(it,_list_front_end_with_execute_loop[i].end());
+        // }
       }
 
@@ -1402,5 +1521,5 @@
     ALLOC1(_execute_loop_nb_packet                                 ,uint32_t,_nb_execute_loop);
     ALLOC1(_execute_loop_nb_thread                                 ,uint32_t,_nb_execute_loop);
-    
+
     for (uint32_t i=0; i<_nb_execute_loop; ++i)
       {
@@ -1453,4 +1572,5 @@
         }  
     
+    ALLOC2(_execute_loop_nb_inst_read                              ,uint32_t,_nb_execute_loop,_nb_read_unit[it1]);
     ALLOC2(_execute_loop_size_read_queue                           ,uint32_t,_nb_execute_loop,_nb_read_unit[it1]);
     ALLOC2(_execute_loop_size_reservation_station                  ,uint32_t,_nb_execute_loop,_nb_read_unit[it1]);
@@ -1468,4 +1588,5 @@
             log_printf(TRACE,Core,FUNCTION,_("      * num_read_bloc : %d"),num_read_bloc);
             
+            _execute_loop_nb_inst_read             [i][j] = _nb_inst_read             [num_read_bloc];
             _execute_loop_size_read_queue          [i][j] = _size_read_queue          [num_read_bloc];
             _execute_loop_size_reservation_station [i][j] = _size_reservation_station [num_read_bloc];
@@ -1538,13 +1659,18 @@
       }
     
-    ALLOC2(_execute_loop_size_store_queue                          ,uint32_t,_nb_execute_loop,_execute_loop_nb_load_store_unit[it1]);
-    ALLOC2(_execute_loop_size_load_queue                           ,uint32_t,_nb_execute_loop,_execute_loop_nb_load_store_unit[it1]);
-    ALLOC2(_execute_loop_size_speculative_access_queue             ,uint32_t,_nb_execute_loop,_execute_loop_nb_load_store_unit[it1]);
-    ALLOC2(_execute_loop_nb_port_check                             ,uint32_t,_nb_execute_loop,_execute_loop_nb_load_store_unit[it1]);
+    ALLOC2(_execute_loop_size_store_queue                          ,uint32_t    ,_nb_execute_loop,_execute_loop_nb_load_store_unit[it1]);
+    ALLOC2(_execute_loop_size_load_queue                           ,uint32_t    ,_nb_execute_loop,_execute_loop_nb_load_store_unit[it1]);
+    ALLOC2(_execute_loop_size_speculative_access_queue             ,uint32_t    ,_nb_execute_loop,_execute_loop_nb_load_store_unit[it1]);
+    ALLOC2(_execute_loop_nb_store_queue_bank                       ,uint32_t    ,_nb_execute_loop,_execute_loop_nb_load_store_unit[it1]);
+    ALLOC2(_execute_loop_nb_load_queue_bank                        ,uint32_t    ,_nb_execute_loop,_execute_loop_nb_load_store_unit[it1]);
+    ALLOC2(_execute_loop_nb_port_check                             ,uint32_t    ,_nb_execute_loop,_execute_loop_nb_load_store_unit[it1]);
     ALLOC2(_execute_loop_speculative_load                          ,multi_execute_loop::execute_loop::Tspeculative_load_t
-                                                                            ,_nb_execute_loop,_execute_loop_nb_load_store_unit[it1]);
-    ALLOC2(_execute_loop_nb_bypass_memory                          ,uint32_t,_nb_execute_loop,_execute_loop_nb_load_store_unit[it1]);
-    ALLOC2(_execute_loop_nb_cache_port                             ,uint32_t,_nb_execute_loop,_execute_loop_nb_load_store_unit[it1]);
-    ALLOC2(_execute_loop_nb_inst_memory                            ,uint32_t,_nb_execute_loop,_execute_loop_nb_load_store_unit[it1]);
+                                                                                ,_nb_execute_loop,_execute_loop_nb_load_store_unit[it1]);
+    ALLOC2(_execute_loop_speculative_commit_predictor_scheme       ,Tpredictor_t,_nb_execute_loop,_execute_loop_nb_load_store_unit[it1]);
+    ALLOC3(_execute_loop_lsu_pht_size_counter                      ,uint32_t    ,_nb_execute_loop,_execute_loop_nb_load_store_unit[it1],1);
+    ALLOC3(_execute_loop_lsu_pht_nb_counter                        ,uint32_t    ,_nb_execute_loop,_execute_loop_nb_load_store_unit[it1],1);
+    ALLOC2(_execute_loop_nb_bypass_memory                          ,uint32_t    ,_nb_execute_loop,_execute_loop_nb_load_store_unit[it1]);
+    ALLOC2(_execute_loop_nb_cache_port                             ,uint32_t    ,_nb_execute_loop,_execute_loop_nb_load_store_unit[it1]);
+    ALLOC2(_execute_loop_nb_inst_memory                            ,uint32_t    ,_nb_execute_loop,_execute_loop_nb_load_store_unit[it1]);
     
     for (uint32_t i=0; i<_nb_execute_loop; ++i)
@@ -1556,14 +1682,23 @@
           log_printf(TRACE,Core,FUNCTION,_("    * nb_bypass_memory : %d"),_nb_bypass_memory[num_load_store_unit]);
 
-          _execute_loop_size_store_queue              [i][j] = _size_store_queue              [num_load_store_unit];
-          _execute_loop_size_load_queue               [i][j] = _size_load_queue               [num_load_store_unit];
-          _execute_loop_size_speculative_access_queue [i][j] = _size_speculative_access_queue [num_load_store_unit];
-          _execute_loop_nb_port_check                 [i][j] = _nb_port_check                 [num_load_store_unit];
-          _execute_loop_speculative_load              [i][j] = _speculative_load              [num_load_store_unit];
-          _execute_loop_nb_bypass_memory              [i][j] = _nb_bypass_memory              [num_load_store_unit];
-          _execute_loop_nb_cache_port                 [i][j] = _nb_cache_port                 [num_load_store_unit];
-          _execute_loop_nb_inst_memory                [i][j] = _nb_inst_memory                [num_load_store_unit];
+          _execute_loop_size_store_queue                    [i][j] = _size_store_queue                    [num_load_store_unit];
+          _execute_loop_size_load_queue                     [i][j] = _size_load_queue                     [num_load_store_unit];
+          _execute_loop_size_speculative_access_queue       [i][j] = _size_speculative_access_queue       [num_load_store_unit];
+          _execute_loop_nb_store_queue_bank                 [i][j] = _nb_store_queue_bank                 [num_load_store_unit];
+          _execute_loop_nb_load_queue_bank                  [i][j] = _nb_load_queue_bank                  [num_load_store_unit];
+          _execute_loop_nb_port_check                       [i][j] = _nb_port_check                       [num_load_store_unit];
+          _execute_loop_speculative_load                    [i][j] = _speculative_load                    [num_load_store_unit];
+          _execute_loop_speculative_commit_predictor_scheme [i][j] = _speculative_commit_predictor_scheme [num_load_store_unit];
+          for (uint32_t k=0; k<1; ++k)
+            {
+          _execute_loop_lsu_pht_size_counter             [i][j][k] = _lsu_pht_size_counter                [num_load_store_unit][k];
+          _execute_loop_lsu_pht_nb_counter               [i][j][k] = _lsu_pht_nb_counter                  [num_load_store_unit][k];
+            }
+          _execute_loop_nb_bypass_memory                    [i][j] = _nb_bypass_memory                    [num_load_store_unit];
+          _execute_loop_nb_cache_port                       [i][j] = _nb_cache_port                       [num_load_store_unit];
+          _execute_loop_nb_inst_memory                      [i][j] = _nb_inst_memory                      [num_load_store_unit];
         }
 
+    ALLOC2(_execute_loop_nb_inst_write                             ,uint32_t,_nb_execute_loop,_nb_write_unit[it1]);
     ALLOC2(_execute_loop_size_write_queue                          ,uint32_t,_nb_execute_loop,_nb_write_unit[it1]);
     ALLOC2(_execute_loop_size_execute_queue                        ,uint32_t,_nb_execute_loop,_nb_write_unit[it1]);
@@ -1576,4 +1711,5 @@
           uint32_t num_write_bloc = _link_write_bloc_with_write_unit [i][j];
     
+          _execute_loop_nb_inst_write      [i][j] = _nb_inst_write      [num_write_bloc];
           _execute_loop_size_write_queue   [i][j] = _size_write_queue   [num_write_bloc];
           _execute_loop_size_execute_queue [i][j] = _size_execute_queue [num_write_bloc];
@@ -1660,5 +1796,5 @@
               
               if (is_lsu)
-                link = _link_read_bloc_and_load_store_unit  [num_read_bloc][num_load_store_unit];
+                link = (_link_read_bloc_with_load_store_unit [num_load_store_unit] == num_read_bloc);
               else
                 link = _link_read_bloc_and_functionnal_unit [num_read_bloc][num_functionnal_unit];
@@ -1689,5 +1825,5 @@
               
               if (is_lsu)
-                link = _link_write_bloc_and_load_store_unit  [num_write_bloc][num_load_store_unit];
+                link = (_link_write_bloc_with_load_store_unit [num_load_store_unit] == num_write_bloc);
               else
                 link = _link_write_bloc_and_functionnal_unit [num_write_bloc][num_functionnal_unit];
@@ -1745,5 +1881,5 @@
               {
                 uint32_t num_write_bloc = _link_write_bloc_with_write_unit[i][k];
-                bool     have_link = (is_lsu)?(_link_write_bloc_and_load_store_unit [num_write_bloc][num_load_store_unit]):(_link_write_bloc_and_functionnal_unit [num_write_bloc][num_functionnal_unit]);
+                bool     have_link = (is_lsu)?(_link_write_bloc_with_load_store_unit [num_load_store_unit]==num_write_bloc):(_link_write_bloc_and_functionnal_unit [num_write_bloc][num_functionnal_unit]);
                   
                 if (have_link)
@@ -1997,5 +2133,5 @@
        _ooo_engine_nb_inst_insert                    [i],
        _ooo_engine_nb_inst_retire                    [i],
-//        _nb_inst_issue                                [i],
+//     _nb_inst_issue                                [i],
        _ooo_engine_nb_inst_execute                   [i],
        _nb_inst_reexecute                            [i],
@@ -2011,4 +2147,5 @@
        _size_re_order_buffer                         [i],
        _nb_re_order_buffer_bank                      [i],
+       _retire_ooo_scheme                            [i],
        _commit_priority                              [i],
        _commit_load_balancing                        [i],
@@ -2021,6 +2158,4 @@
 //        _ooo_engine_table_issue_type                  [i],
        _size_reexecute_queue                         [i],
-       _reexecute_priority                           [i],
-       _reexecute_load_balancing                     [i],
        _ooo_engine_rename_select_priority            [i],
        _ooo_engine_rename_select_load_balancing      [i],
@@ -2060,4 +2195,5 @@
          _size_special_data                                          ,
 
+         _execute_loop_nb_inst_read                               [i],
          _execute_loop_size_read_queue                            [i],
          _execute_loop_size_reservation_station                   [i],
@@ -2071,10 +2207,16 @@
          _execute_loop_size_load_queue                            [i],
          _execute_loop_size_speculative_access_queue              [i],
+         _execute_loop_nb_store_queue_bank                        [i],
+         _execute_loop_nb_load_queue_bank                         [i],
          _execute_loop_nb_port_check                              [i],
          _execute_loop_speculative_load                           [i],
+         _execute_loop_speculative_commit_predictor_scheme        [i],
+         _execute_loop_lsu_pht_size_counter                       [i],
+         _execute_loop_lsu_pht_nb_counter                         [i],
          _execute_loop_nb_bypass_memory                           [i],
          _execute_loop_nb_cache_port                              [i],
          _execute_loop_nb_inst_memory                             [i],
 
+         _execute_loop_nb_inst_write                              [i],
          _execute_loop_size_write_queue                           [i],
          _execute_loop_size_execute_queue                         [i],
@@ -2146,37 +2288,39 @@
     _param_glue          = new core::core_glue::Parameters 
       (
-       _nb_front_end                         ,
-       _nb_context                           ,//[nb_front_end]
-       _nb_ooo_engine                        ,
-       _nb_execute_loop                      ,
-       _ooo_engine_nb_front_end              ,//[nb_ooo_engine]
-       _ooo_engine_nb_execute_loop           ,//[nb_ooo_engine]
-       _execute_loop_nb_ooo_engine           ,//[nb_execute_loop]
-       _front_end_sum_inst_decod             ,//[nb_front_end] -> [sum_inst_decod]
-       _front_end_nb_inst_branch_complete    ,//[nb_front_end]
-       _nb_inst_branch_complete              ,//[nb_ooo_engine]
-//     _ooo_engine_nb_inst_insert_rob        ,//[nb_ooo_engine]
-       _nb_inst_reexecute                    ,//[nb_ooo_engine]
-       _nb_inst_issue_queue                  ,//[nb_ooo_engine]
-       _nb_inst_issue_slot                   ,//[nb_ooo_engine]
-       _ooo_engine_nb_inst_execute           ,//[nb_ooo_engine][ooo_engine_nb_execute_loop]
-       _issue_queue_in_order                 ,//[nb_ooo_engine]
-       _nb_read_unit                         ,//[nb_execute_loop]
-       _nb_write_unit                        ,//[nb_execute_loop]
-       _size_depth                           ,
-       _size_rob_ptr                         ,
-       _size_load_queue_ptr                  ,
-       _size_store_queue_ptr                 ,
-       _size_general_data                    ,
-       _size_special_data                    ,
-       _size_general_register                ,
-       _size_special_register                ,
-       _dispatch_priority                    ,
-       _dispatch_load_balancing              ,
-       _network_table_dispatch               ,//[nb_ooo_engine][nb_inst_issue_slot][nb_execute_loop][nb_read_unit]
-       _network_table_issue_type             ,//                                   [nb_execute_loop][nb_read_unit][nb_type]
-       _translate_ooo_engine_num_front_end   ,//[nb_ooo_engine][ooo_engine_nb_front_end]
-       _translate_ooo_engine_num_execute_loop,//[nb_ooo_engine][ooo_engine_nb_execute_loop]
-       _translate_execute_loop_num_ooo_engine //[nb_execute_loop][execute_loop_nb_ooo_engine]
+       _nb_front_end                                  ,
+       _nb_context                                    ,//[nb_front_end]
+       _nb_ooo_engine                                 ,
+       _nb_execute_loop                               ,
+       _ooo_engine_nb_front_end                       ,//[nb_ooo_engine]
+       _ooo_engine_nb_execute_loop                    ,//[nb_ooo_engine]
+       _execute_loop_nb_ooo_engine                    ,//[nb_execute_loop]
+       _front_end_sum_inst_decod                      ,//[nb_front_end] -> [sum_inst_decod]
+       _front_end_nb_inst_branch_complete             ,//[nb_front_end]
+       _nb_inst_branch_complete                       ,//[nb_ooo_engine]
+//     _ooo_engine_nb_inst_insert_rob                 ,//[nb_ooo_engine]
+       _nb_inst_reexecute                             ,//[nb_ooo_engine]
+       _nb_inst_issue_queue                           ,//[nb_ooo_engine]
+//     _nb_inst_issue_slot                            ,//[nb_ooo_engine]
+       _ooo_engine_nb_inst_execute                    ,//[nb_ooo_engine][ooo_engine_nb_execute_loop]
+       _issue_queue_in_order                          ,//[nb_ooo_engine]
+       _nb_read_unit                                  ,//[nb_execute_loop]
+       _nb_write_unit                                 ,//[nb_execute_loop]
+       _size_depth                                    ,
+       _size_rob_ptr                                  ,
+       _size_load_queue_ptr                           ,
+       _size_store_queue_ptr                          ,
+       _size_general_data                             ,
+       _size_special_data                             ,
+       _size_general_register                         ,
+       _size_special_register                         ,
+       _dispatch_priority                             ,
+       _dispatch_load_balancing                       ,
+//     _network_table_dispatch                        ,//[nb_ooo_engine][nb_inst_issue_slot][nb_execute_loop][nb_read_unit]
+       _network_table_issue_type                      ,//                                   [nb_execute_loop][nb_read_unit][nb_type]
+       _network_table_issue_thread                    ,//                                   [nb_execute_loop][nb_read_unit][nb_thread]
+       _translate_ooo_engine_num_front_end            ,//[nb_ooo_engine][ooo_engine_nb_front_end]
+       _translate_ooo_engine_num_execute_loop         ,//[nb_ooo_engine][ooo_engine_nb_execute_loop]
+       _translate_execute_loop_num_ooo_engine         ,//[nb_execute_loop][execute_loop_nb_ooo_engine]
+       _ooo_engine_translate_num_context_to_num_thread //[nb_ooo_engine][ooo_engine_nb_front_end][nb_context]
        );
     
@@ -2238,9 +2382,15 @@
     DELETE2(_execute_loop_size_execute_queue                        ,_nb_execute_loop,_nb_write_unit[it1]);
     DELETE2(_execute_loop_size_write_queue                          ,_nb_execute_loop,_nb_write_unit[it1]);
+    DELETE2(_execute_loop_nb_inst_write                             ,_nb_execute_loop,_nb_write_unit[it1]);
     DELETE2(_execute_loop_nb_inst_memory                            ,_nb_execute_loop,_execute_loop_nb_load_store_unit[it1]);
     DELETE2(_execute_loop_nb_cache_port                             ,_nb_execute_loop,_execute_loop_nb_load_store_unit[it1]);
     DELETE2(_execute_loop_nb_bypass_memory                          ,_nb_execute_loop,_execute_loop_nb_load_store_unit[it1]);
+    DELETE3(_execute_loop_lsu_pht_nb_counter                        ,_nb_execute_loop,_execute_loop_nb_load_store_unit[it1],1);
+    DELETE3(_execute_loop_lsu_pht_size_counter                      ,_nb_execute_loop,_execute_loop_nb_load_store_unit[it1],1);
+    DELETE2(_execute_loop_speculative_commit_predictor_scheme       ,_nb_execute_loop,_execute_loop_nb_load_store_unit[it1]);
     DELETE2(_execute_loop_speculative_load                          ,_nb_execute_loop,_execute_loop_nb_load_store_unit[it1]);
     DELETE2(_execute_loop_nb_port_check                             ,_nb_execute_loop,_execute_loop_nb_load_store_unit[it1]);
+    DELETE2(_execute_loop_nb_load_queue_bank                        ,_nb_execute_loop,_execute_loop_nb_load_store_unit[it1]);
+    DELETE2(_execute_loop_nb_store_queue_bank                       ,_nb_execute_loop,_execute_loop_nb_load_store_unit[it1]);
     DELETE2(_execute_loop_size_speculative_access_queue             ,_nb_execute_loop,_execute_loop_nb_load_store_unit[it1]);
     DELETE2(_execute_loop_size_load_queue                           ,_nb_execute_loop,_execute_loop_nb_load_store_unit[it1]);
@@ -2253,4 +2403,5 @@
     DELETE2(_execute_loop_size_reservation_station                  ,_nb_execute_loop,_nb_read_unit[it1]);
     DELETE2(_execute_loop_size_read_queue                           ,_nb_execute_loop,_nb_read_unit[it1]);
+    DELETE2(_execute_loop_nb_inst_read                              ,_nb_execute_loop,_nb_read_unit[it1]);
     DELETE2(_translate_execute_loop_num_ooo_engine                  ,_nb_execute_loop,_execute_loop_nb_ooo_engine[it1]);
     DELETE1(_execute_loop_nb_thread                                 ,_nb_execute_loop);
@@ -2273,6 +2424,7 @@
 //  DELETE3(_ooo_engine_table_issue_type                            ,_nb_ooo_engine,_nb_inst_issue_slot[it1],_nb_type);
 //  DELETE3(_ooo_engine_table_routing                               ,_nb_ooo_engine,_nb_rename_unit[it1],_nb_inst_issue_slot[it1]);
+    DELETE3(_network_table_issue_thread                                                                     ,_nb_execute_loop,_nb_read_unit[it1],_nb_thread);
     DELETE3(_network_table_issue_type                                                                       ,_nb_execute_loop,_nb_read_unit[it1],_nb_type);
-    DELETE4(_network_table_dispatch                                 ,_nb_ooo_engine,_nb_inst_issue_slot[it1],_nb_execute_loop,_nb_read_unit[it3]);
+//  DELETE4(_network_table_dispatch                                 ,_nb_ooo_engine,_nb_inst_issue_slot[it1],_nb_execute_loop,_nb_read_unit[it3]);
 //  DELETE2(_ooo_engine_size_read_counter                           ,_nb_ooo_engine,_nb_rename_unit[it1]);
     DELETE2(_ooo_engine_nb_rename_unit_bank                         ,_nb_ooo_engine,_nb_rename_unit[it1]);
